<?php
class Controller{
	private $acceptableCommands;
    //Controller constructor
	function __construct(){
        //set up the map values
		$this->acceptableCommands = array("pat"=>"patient", "nur"=>"nurse", 
        "pat_vis"=>"patientVisit", "noCmd"=>"noCmd", "ret_pat_nur"=>"retrievePatNurse",
        "update_pat_nur"=>"updatePatNurse", "sup_inv"=>"supplierInventoryListing", 
        "cur_inv"=>"localInventoryListing", "inv_cost"=>"localInventoryCost",
        "login"=>"login", "mashup"=>"mashup", "store"=>"storeSession", "doct"=>"doctor", 
        "crRepDef"=>"createReportDef","delRepDef"=>"deleteReportDef",
        "strRepDef"=>"storeReportDef", "viewAllRepDef"=>"viewAllReportDefs", 
        "viewRepDef"=>"viewReportDef", "prevRep"=>"previewReport",
        "rmvRepDef"=>"removeReportDef"); 
	}
	function dispatch($cmd, $type, $data)
	{
		$functionName = "badCommand".$type;
        if($this->acceptableCommands[$cmd]){
            $functionName = $this->acceptableCommands[$cmd].$type;
        }
        //include the file containing the BCO or VCO needed.
        require_once getcwd().DIRECTORY_SEPARATOR.$functionName.".inc";
        //instantiate the control object
        $aControlObject = new $functionName($data);
        $returnedData = $aControlObject->execute();
        return $returnedData;
	}
}
?>
